## syslinux 6.03+dfsg1

=== Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 1998-2009 H. Peter Anvin - All Rights Reserved
##   Copyright 2009-2014 Intel Corporation; author: H. Peter Anvin
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

#
# Main Makefile for SYSLINUX
#

all_firmware := bios efi32 efi64

#
# topdir is only set when we are doing a recursive make. Do a bunch of
# initialisation if it's unset since this is the first invocation.
#
ifeq ($(topdir),)

topdir = $(CURDIR)

#
# Because we need to build modules multiple times, e.g. for BIOS,
# efi32, efi64, we output all object and executable files to a
# separate object directory for each firmware.
#
# The output directory can be customised by setting the O=/obj/path/
# variable when invoking make. If no value is specified the default
# directory is the top-level of the Syslinux source.
#
ifeq ("$(origin O)", "command line")
	OBJDIR := $(O)
else
	OBJDIR = $(topdir)
endif

# If the output directory does not exist we bail because that is the
# least surprising thing to do.
cd-output := $(shell cd $(OBJDIR) && /bin/pwd)
$(if $(cd-output),, \
	$(error output directory "$(OBJDIR)" does not exist))

#
# These environment variables are exported to every invocation of
# make,
#
# 'topdir' - the top-level directory containing the Syslinux source
# 'objdir' - the top-level directory of output files for this firmware
# 'MAKEDIR' - contains Makefile fragments
# 'OBJDIR' - the top-level directory of output files
#
# There are also a handful of variables that are passed to each
# sub-make,
#
# SRC - source tree location of the module being compiled
# OBJ - output tree location of the module being compiled
#
# A couple of rules for writing Makefiles,
#
# - Do not use relative paths, use the above variables
# - You can write $(SRC) a lot less if you add it to VPATH
#

MAKEDIR = $(topdir)/mk
export MAKEDIR topdir OBJDIR

include $(MAKEDIR)/syslinux.mk
-include $(OBJDIR)/version.mk

private-targets = prerel unprerel official release burn isolinux.iso \
		  preupload upload test unittest regression spotless

ifeq ($(MAKECMDGOALS),)
	MAKECMDGOALS += all
endif

#
# The 'bios', 'efi32' and 'efi64' are dummy targets. Their only
# purpose is to instruct us which output directories need
# creating. Which means that we always need a *real* target, such as
# 'all', appended to the make goals.
#
firmware = $(all_firmware)
real-target := $(filter-out $(firmware), $(MAKECMDGOALS))
real-firmware := $(filter $(firmware), $(MAKECMDGOALS))

ifeq ($(real-target),)
	real-target = all
endif

ifeq ($(real-firmware),)
	real-firmware = $(firmware)
endif

.PHONY: $(filter-out $(private-targets), $(MAKECMDGOALS))
$(filter-out $(private-targets), $(MAKECMDGOALS)):
	$(MAKE) -C $(OBJDIR) -f $(CURDIR)/Makefile SRC="$(topdir)" \
		OBJ=$(OBJDIR) objdir=$(OBJDIR) $(MAKECMDGOALS)

unittest:
	printf "Executing unit tests\n"
	$(MAKE) -C core/mem/tests all
	$(MAKE) -C com32/lib/syslinux/tests all

regression:
	$(MAKE) -C tests SRC="$(topdir)/tests" OBJ="$(topdir)/tests" \
		objdir=$(OBJDIR) \
		-f $(topdir)/tests/Makefile all

test: unittest regression

# Hook to add private Makefile targets for the maintainer.
-include $(topdir)/Makefile.private

else # ifeq ($(topdir),)

include $(MAKEDIR)/syslinux.mk

# Hook to add private Makefile targets for the maintainer.
-include $(topdir)/Makefile.private

#
# The BTARGET refers to objects that are derived from ldlinux.asm; we
# like to keep those uniform for debugging reasons; however, distributors
# want to recompile the installers (ITARGET).
#
# BOBJECTS and IOBJECTS are the same thing, except used for
# installation, so they include objects that may be in subdirectories
# with their own Makefiles.  Finally, there is a list of those
# directories.
#

ifndef EFI_BUILD
MODULES = memdisk/memdisk \
	com32/menu/*.c32 com32/modules/*.c32 com32/mboot/*.c32 \
	com32/hdt/*.c32 com32/rosh/*.c32 com32/gfxboot/*.c32 \
	com32/sysdump/*.c32 com32/lua/src/*.c32 com32/chain/*.c32 \
	com32/lib/*.c32 com32/libutil/*.c32 com32/gpllib/*.c32 \
	com32/elflink/ldlinux/*.c32 com32/cmenu/libmenu/*.c32
else
# FIXME: Prune other BIOS-centric modules
MODULES = com32/menu/*.c32 com32/modules/*.c32 com32/mboot/*.c32 \
	com32/hdt/*.c32 com32/rosh/*.c32 com32/gfxboot/*.c32 \
	com32/sysdump/*.c32 com32/lua/src/*.c32 com32/chain/*.c32 \
	com32/lib/*.c32 com32/libutil/*.c32 com32/gpllib/*.c32 \
	com32/cmenu/libmenu/*.c32 com32/elflink/ldlinux/$(LDLINUX)
endif

# List of module objects that should be installed for all derivatives
INSTALLABLE_MODULES = $(MODULES)

# syslinux.exe is BTARGET so as to not require everyone to have the
# mingw suite installed
BTARGET  = version.gen version.h $(OBJDIR)/version.mk
BOBJECTS = $(BTARGET) \
	mbr/*.bin \
	core/pxelinux.0 core/lpxelinux.0 \
	core/isolinux.bin core/isolinux-debug.bin \
	gpxe/gpxelinux.0 dos/syslinux.com \
	win32/syslinux.exe win64/syslinux64.exe \
	dosutil/*.com dosutil/*.sys \
	$(MODULES)

# BSUBDIRs build the on-target binary components.
# ISUBDIRs build the installer (host) components.
#
# Note: libinstaller is both a BSUBDIR and an ISUBDIR.  It contains
# files that depend only on the B phase, but may have to be regenerated
# for "make installer".

ifdef EFI_BUILD

BSUBDIRS = codepage com32 lzo core mbr sample efi txt
ISUBDIRS =

INSTALLSUBDIRS = efi

NETINSTALLABLE = efi/syslinux.efi $(INSTALLABLE_MODULES)

else

BSUBDIRS = codepage com32 lzo core memdisk mbr gpxe sample \
	   diag libinstaller dos win32 win64 dosutil txt

ITARGET  =
IOBJECTS = $(ITARGET) \
	utils/gethostip utils/isohybrid utils/mkdiskimage \
	mtools/syslinux linux/syslinux extlinux/extlinux
ISUBDIRS = libinstaller mtools linux extlinux utils

# Things to install in /usr/bin
INSTALL_BIN   =	mtools/syslinux
# Things to install in /sbin
INSTALL_SBIN  = extlinux/extlinux
# Things to install in /usr/lib/syslinux
INSTALL_AUX   =	core/pxelinux.0 gpxe/gpxelinux.0 gpxe/gpxelinuxk.0 \
		core/isolinux.bin core/isolinux-debug.bin \
		dos/syslinux.com core/lpxelinux.0 \
		mbr/*.bin $(INSTALLABLE_MODULES)
INSTALL_AUX_OPT = win32/syslinux.exe win64/syslinux64.exe
INSTALL_DIAG  =	diag/mbr/handoff.bin \
		diag/geodsp/geodsp1s.img.xz diag/geodsp/geodspms.img.xz

# These directories manage their own installables
INSTALLSUBDIRS = com32 utils dosutil

# Things to install in /boot/extlinux
EXTBOOTINSTALL = $(INSTALLABLE_MODULES)

# Things to install in /tftpboot
NETINSTALLABLE = core/pxelinux.0 gpxe/gpxelinux.0 core/lpxelinux.0 \
		 $(INSTALLABLE_MODULES)

endif # ifdef EFI_BUILD

.PHONY: subdirs $(BSUBDIRS) $(ISUBDIRS) test

ifeq ($(HAVE_FIRMWARE),)

firmware = $(all_firmware)

# If no firmware was specified the rest of MAKECMDGOALS applies to all
# firmware.
ifeq ($(filter $(firmware),$(MAKECMDGOALS)),)
all strip tidy clean dist install installer netinstall: $(all_firmware)

else

# Don't do anything for the rest of MAKECMDGOALS at this level. It
# will be handled for each of $(firmware).
strip tidy clean dist install installer netinstall:

endif

# Convert 'make bios strip' to 'make strip', etc for rest of the Makefiles.
MAKECMDGOALS := $(filter-out $(firmware),$(MAKECMDGOALS))
ifeq ($(MAKECMDGOALS),)
	MAKECMDGOALS += all
endif

#
# You'd think that we'd be able to use the 'define' directive to
# abstract the code for invoking make(1) in the output directory, but
# by using 'define' we lose the ability to build in parallel.
#
.PHONY: $(firmware)
bios:
	@mkdir -p $(OBJ)/bios
	$(MAKE) -C $(OBJ)/bios -f $(SRC)/Makefile SRC="$(SRC)" \
		objdir=$(OBJ)/bios OBJ=$(OBJ)/bios HAVE_FIRMWARE=1 \
		FIRMWARE=BIOS \
		ARCH=i386 LDLINUX=ldlinux.c32 $(MAKECMDGOALS)

efi32:
	@mkdir -p $(OBJ)/efi32
	$(MAKE) -C $(OBJ)/efi32 -f $(SRC)/Makefile SRC="$(SRC)" \
		objdir=$(OBJ)/efi32 OBJ=$(OBJ)/efi32 HAVE_FIRMWARE=1 \
		ARCH=i386 BITS=32 EFI_BUILD=1 LDLINUX=ldlinux.e32 \
		FIRMWARE=EFI32 \
		$(MAKECMDGOALS)

efi64:
	@mkdir -p $(OBJ)/efi64
	$(MAKE) -C $(OBJ)/efi64 -f $(SRC)/Makefile SRC="$(SRC)" \
		objdir=$(OBJ)/efi64 OBJ=$(OBJ)/efi64 HAVE_FIRMWARE=1 \
		ARCH=x86_64 BITS=64 EFI_BUILD=1 LDLINUX=ldlinux.e64 \
		FIRMWARE=EFI64 \
		$(MAKECMDGOALS)

else # ifeq($(HAVE_FIRMWARE),)

all: all-local subdirs

all-local: $(BTARGET) $(ITARGET)
	-ls -l $(BOBJECTS) $(IOBJECTS)
subdirs: $(BSUBDIRS) $(ISUBDIRS)

$(sort $(ISUBDIRS) $(BSUBDIRS)):
	@mkdir -p $@
	$(MAKE) -C $@ SRC="$(SRC)/$@" OBJ="$(OBJ)/$@" \
		-f $(SRC)/$@/Makefile $(MAKECMDGOALS)

$(ITARGET):
	@mkdir -p $@
	$(MAKE) -C $@ SRC="$(SRC)/$@" OBJ="$(OBJ)/$@" \
		-f $(SRC)/$@/Makefile $(MAKECMDGOALS)

$(BINFILES):
	@mkdir -p $@
	$(MAKE) -C $@ SRC="$(SRC)/$@" OBJ="$(OBJ)/$@" \
		-f $(SRC)/$@/Makefile $(MAKECMDGOALS)

#
# List the dependencies to help out parallel builds.
dos extlinux linux mtools win32 win64: libinstaller
libinstaller: core
utils: mbr
core: com32
efi: core
gpxe: core

installer: installer-local
	set -e; for i in $(ISUBDIRS); \
		do $(MAKE) -C $$i SRC="$(SRC)/$$i" OBJ="$(OBJ)/$$i" \
		-f $(SRC)/$$i/Makefile all; done


installer-local: $(ITARGET) $(BINFILES)

strip: strip-local
	set -e; for i in $(ISUBDIRS); \
		do $(MAKE) -C $$i SRC="$(SRC)/$$i" OBJ="$(OBJ)/$$i" \
		-f $(SRC)/$$i/Makefile strip; done
	-ls -l $(BOBJECTS) $(IOBJECTS)

strip-local:

version.gen: $(topdir)/version $(topdir)/version.pl
	$(PERL) $(topdir)/version.pl $< $@ '%define < @'
version.h: $(topdir)/version $(topdir)/version.pl
	$(PERL) $(topdir)/version.pl $< $@ '#define < @'

local-install: installer
	mkdir -m 755 -p $(INSTALLROOT)$(BINDIR)
	install -m 755 -c $(INSTALL_BIN) $(INSTALLROOT)$(BINDIR)
	mkdir -m 755 -p $(INSTALLROOT)$(SBINDIR)
	install -m 755 -c $(INSTALL_SBIN) $(INSTALLROOT)$(SBINDIR)
	mkdir -m 755 -p $(INSTALLROOT)$(AUXDIR)
	install -m 644 -c $(INSTALL_AUX) $(INSTALLROOT)$(AUXDIR)
	-install -m 644 -c $(INSTALL_AUX_OPT) $(INSTALLROOT)$(AUXDIR)
	mkdir -m 755 -p $(INSTALLROOT)$(DIAGDIR)
	install -m 644 -c $(INSTALL_DIAG) $(INSTALLROOT)$(DIAGDIR)
	mkdir -m 755 -p $(INSTALLROOT)$(MANDIR)/man1
	install -m 644 -c $(topdir)/man/*.1 $(INSTALLROOT)$(MANDIR)/man1
	: mkdir -m 755 -p $(INSTALLROOT)$(MANDIR)/man8
	: install -m 644 -c man/*.8 $(INSTALLROOT)$(MANDIR)/man8

ifndef EFI_BUILD
install: local-install
	set -e ; for i in $(INSTALLSUBDIRS) ; \
		do $(MAKE) -C $$i SRC="$(SRC)/$$i" OBJ="$(OBJ)/$$i" \
		-f $(SRC)/$$i/Makefile $@; done
else
install:
	mkdir -m 755 -p $(INSTALLROOT)$(AUXDIR)/efi$(BITS)
	set -e ; for i in $(INSTALLSUBDIRS) ; \
		do $(MAKE) -C $$i SRC="$(SRC)/$$i" OBJ="$(OBJ)/$$i" \
		BITS="$(BITS)" AUXDIR="$(AUXDIR)/efi$(BITS)" \
		-f $(SRC)/$$i/Makefile $@; done
	-install -m 644 $(INSTALLABLE_MODULES) $(INSTALLROOT)$(AUXDIR)/efi$(BITS)
	install -m 644 com32/elflink/ldlinux/$(LDLINUX) $(INSTALLROOT)$(AUXDIR)/efi$(BITS)
endif

ifdef EFI_BUILD
netinstall:
	mkdir -p $(INSTALLROOT)$(TFTPBOOT)/efi$(BITS)
	install -m 644 $(NETINSTALLABLE) $(INSTALLROOT)$(TFTPBOOT)/efi$(BITS)
else
netinstall: installer
	mkdir -p $(INSTALLROOT)$(TFTPBOOT)
	install -m 644 $(NETINSTALLABLE) $(INSTALLROOT)$(TFTPBOOT)
endif

extbootinstall: installer
	mkdir -m 755 -p $(INSTALLROOT)$(EXTLINUXDIR)
	install -m 644 $(EXTBOOTINSTALL) $(INSTALLROOT)$(EXTLINUXDIR)

install-all: install netinstall extbootinstall

local-tidy:
	rm -f *.o *.elf *_bin.c stupid.* patch.offset
	rm -f *.lsr *.lst *.map *.sec *.tmp
	rm -f $(OBSOLETE)

tidy: local-tidy $(BESUBDIRS) $(IESUBDIRS) $(BSUBDIRS) $(ISUBDIRS)

local-clean:
	rm -f $(ITARGET)

clean: local-tidy local-clean $(BESUBDIRS) $(IESUBDIRS) $(BSUBDIRS) $(ISUBDIRS)

local-dist:
	find . \( -name '*~' -o -name '#*' -o -name core \
		-o -name '.*.d' -o -name .depend \) -type f -print0 \
	| xargs -0rt rm -f

=== com32/gdbstub/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 2001-2008 H. Peter Anvin - All Rights Reserved
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
##   Boston MA 02110-1301, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

##
## GDB remote debugging
##

topdir = ../..
MAKEDIR = $(topdir)/mk
include $(MAKEDIR)/com32.mk

CFLAGS += -fPIE

LIBS	   = ../libutil/libutil_com.a ../lib/libcom32.a $(LIBGCC)
LNXLIBS	   = ../libutil/libutil_lnx.a

MODULES	  = gdbstub.c32
TESTFILES =

OBJS = main.o int.o serial.o gdbstub.o

all: $(MODULES) $(TESTFILES)

gdbstub.elf : $(OBJS) $(LIBS) $(C_LIBS)
	$(LD) $(LDFLAGS) -o $@ $^

tidy dist clean:
	rm -f *.o *.lo *.a *.lst *.elf .*.d *.tmp

clean: tidy
	rm -f *.lnx

spotless: clean
	rm -f *.lss *.c32 *.com
	rm -f *~ \#*

install:
	mkdir -m 755 -p $(INSTALLROOT)$(AUXDIR)
	install -m 644 $(MODULES) $(INSTALLROOT)$(AUXDIR)

-include .*.d

=== com32/samples/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 2001-2008 H. Peter Anvin - All Rights Reserved
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

##
## samples for syslinux users
##

LIBS = $(objdir)/com32/libutil/libutil.c32

VPATH = $(SRC)
include $(MAKEDIR)/elf.mk

all:	hello.c32 resolv.c32 serialinfo.c32 \
		localboot.c32 \
		fancyhello.c32 fancyhello.lnx \
		keytest.c32 keytest.lnx \
		advdump.c32 entrydump.c32

tidy dist:
	rm -f *.o *.lo *.a *.lst *.elf .*.d *.tmp

clean: tidy
	rm -f *.lnx

spotless: clean
	rm -f *.lss *.c32 *.com
	rm -f *~ \#*

install:	# Don't install samples

-include .*.d

=== diag/geodsp/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 2010-2011 Gene Cumm
##
##   Portions from core/Makefile:
##   Copyright 1998-2009 H. Peter Anvin - All Rights Reserved
##   Copyright 2009-2010 Intel Corporation; author: H. Peter Anvin
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

#
# Makefile for the SYSLINUX geometry display for diagnostics
#

include $(MAKEDIR)/embedded.mk
coredir = $(topdir)/core
VPATH = $(SRC)

BTARGET = geodsp1s.bin geodspms.bin \
	geodsp1s.img.xz geodspms.img.xz

NASMOPT = -i $(coredir)/ -i $(SRC)/ -Ox -f bin -dBINFMT
NASMOPT += -w+orphan-labels
CFLAGS = -g -O

all: $(BTARGET)

# Higher compression levels result in larger files
%.img.xz: %.bin mk-lba-img.pl
	$(PERL) $(SRC)/mk-lba-img.pl $< | $(XZ) -0 > $@ || ( rm -f $@ ; false )

%.img.gz: %.bin mk-lba-img.pl
	$(PERL) $(SRC)/mk-lba-img.pl $< | $(GZIPPROG) -9 > $@ || ( rm -f $@ ; false )

# in case someone really wants these without needing a decompressor
%.img: %.bin mk-lba-img.pl
	$(PERL) $(SRC)/mk-lba-img.pl $< > $@ || ( rm -f $@ ; false )

%.bin: %.asm $(coredir)/writehex.inc $(coredir)/macros.inc $(coredir)/diskboot.inc
	$(NASM) $(NASMOPT) -o $@ -l $(@:.bin=.lst) $<

mk-lba-img: mk-lba-img.c
	$(CC) $(CFLAGS) -o $@ $<

tidy dist:
	rm -Rf *.lst *.img
	rm -f mk-lba-img

clean: tidy

spotless: clean
	rm -f $(BTARGET)

=== gnu-efi/gnu-efi-3.0/lib/Makefile ===
#
#  Copyright (C) 1999-2001 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
#    All rights reserved.
#
#    Redistribution and use in source and binary forms, with or without
#    modification, are permitted provided that the following conditions
#    are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials
#      provided with the distribution.
#    * Neither the name of Hewlett-Packard Co. nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
#    CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
#    BE LIABLE FOR ANYDIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
#    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
#    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#    SUCH DAMAGE.
#

SRCDIR = .

VPATH = $(SRCDIR)

include $(SRCDIR)/../Make.defaults

TOPDIR = $(SRCDIR)/..

CDIR = $(TOPDIR)/..
FILES = argify boxdraw smbios console crc data debug dpath  \
        error event guid hand hw init lock   \
        misc print sread str \
	runtime/rtlock runtime/efirtlib runtime/rtstr runtime/vm runtime/rtdata  \
	$(ARCH)/initplat $(ARCH)/math 

ifeq ($(ARCH),ia64)
FILES += $(ARCH)/salpal $(ARCH)/palproc
endif

ifeq ($(ARCH),x86_64)
FILES += $(ARCH)/callwrap $(ARCH)/efi_stub
endif

OBJS  = $(FILES:%=%.o)

SUBDIRS = ia32 x86_64 ia64 runtime

all: libsubdirs libefi.a

libsubdirs:
	for sdir in $(SUBDIRS); do mkdir -p $$sdir; done

libefi.a: $(patsubst %,libefi.a(%),$(OBJS))

clean:
	rm -f libefi.a *~ $(OBJS) */*.o

install: libefi.a
	mkdir -p $(INSTALLROOT)/$(LIBDIR)
	$(INSTALL) -m 644 libefi.a $(INSTALLROOT)/$(LIBDIR)

include $(SRCDIR)/../Make.rules

.PHONY: libsubdirs

=== debian/changelog ===
syslinux (3:6.03+dfsg1-2) unstable; urgency=medium

  * Update 0004-gnu-efi.patch to use the jmp_buf definition from gnu-efi.
  * Add patch 0018-ext4-Fix-64bit-feature.patch from upstream to support ext4
    64bit feature (Closes: #833057).
  * Mark isolinux, pxelinux, syslinux-common and syslinux-efi as
    Multi-Arch: foreign.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Tue, 17 Oct 2017 23:41:05 +0200

syslinux (3:6.03+dfsg1-1) unstable; urgency=low

  * Maintain syslinux in the debian-cd team (Closes: #805268).
    - Change Vcs-{Browser,Git} in debian/control accordingly.
    - Add debian/gbp.conf to set suitable defaults for git-buildpackage.
  * Add debian/watch file.
  * Implement repacking using uscan (add Files-Excluded field to
    debian/copyright and drop dfsg target in debian/rules).
  * New repack to remove build directories (bios, efi32, efi64) and
    gnu-efi/gnu-efi-3.0/debian from the source package.
  * Cleanup debian/rules: use debhelper config files more extensively.
  * Move to debhelper compatibility level 10, depend on debhelper 10.3 for
    dh_missing.
  * Add debian/clean to remove debris from build.
  * Update the variables passed to make for building:
    - Passing VERSION is no longer required.
    - Derive DATE from SOURCE_DATE_EPOCH.
    - Also pass HEXDATE derived from SOURCE_DATE_EPOCH.
  * Add patch to make the use SOURCE_DATE_EPOCH for the synthesized
    modification time constants.  This allows syslinux to build reproducibly
    as long as the build path stays the same.
  * Link efi binaries against gnu-efi from Debian:
    - Add Build-Depends-Indep on gnu-efi (an architecture independent
      dependency is necessary as gnu-efi is not available on x32).
    - Split the build in debian/rules for arch all/any packets so gnu-efi is
      not required for architecture specific builds.
    - Patch upstream's build system (by modifying 0004-gnu-efi.patch) to link
      against gnu-efi from Debian.
    - Record the static linking with gnu-efi (Built-Using control field).
  * Drop unused lintian overrides.
  * Add patch from upstream to fix btrfs logical to physical block address
    mapping (Closes: #865462).
  * Add patch from upstream to fix boot problem for old BIOS firmware from
    around 2005 by correcting the C/H/S order (thanks Thomas Schmitt).
  * Bump Standards-Version to 4.1.1.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 07 Oct 2017 17:48:54 +0200

=== debian/control ===
Source: syslinux
Section: admin
Priority: optional
Maintainer: Debian CD Group <debian-cd@lists.debian.org>
Uploaders: Lukas Schwaighofer <lukas@schwaighofer.name>
Build-Depends:
 debhelper (>= 10.3),
 e2fslibs-dev,
 gcc-multilib [amd64 x32],
 libc6-dev-i386 [amd64 x32],
 nasm,
 python,
 uuid-dev,
Build-Depends-Indep: gnu-efi
Standards-Version: 4.1.1
Homepage: http://www.syslinux.org/
Vcs-Git: https://anonscm.debian.org/git/debian-cd/syslinux.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-cd/syslinux.git

Package: syslinux
Architecture: amd64 i386 x32
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
  mtools,
Recommends: syslinux-common
Suggests: dosfstools
Description: collection of bootloaders (DOS FAT and NTFS bootloader)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the bootloader for DOS FAT and NTFS filesystems
 (SYSLINUX).

Package: syslinux-efi
Architecture: all
Multi-Arch: foreign
Built-Using: ${built:Using}
Depends: ${misc:Depends}
Recommends: syslinux-common
Suggests: dosfstools
Description: collection of bootloaders (UEFI bootloader)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the bootloader for the Unified Extensible Firmware
 Interface (EFI).

Package: extlinux
Architecture: amd64 i386 x32
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends: syslinux-common
Description: collection of bootloaders (Linux ext2/ext3/ext4, btrfs, and xfs bootloader)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the bootloader for Linux ext2/ext3/ext4, btrfs, and xfs
 filesystems (EXTLINUX).

Package: isolinux
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: syslinux-common
Suggests: xorriso
Description: collection of bootloaders (ISO 9660 bootloader)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the bootloader for ISO 9660 CD-ROMs (ISOLINUX).

Package: pxelinux
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: syslinux-common
Suggests: tftpd-hpa
Description: collection of bootloaders (PXE network bootloader)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the bootloader for PXE network boots (PXELINUX).

Package: syslinux-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: collection of bootloaders (common)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the common files.

Package: syslinux-utils
Architecture: amd64 i386 x32
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libcrypt-passwdmd5-perl,
 libdigest-sha-perl,
Description: collection of bootloaders (utilities)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the auxiliary utilities.

=== debian/rules ===
#!/usr/bin/make -f

SHELL := sh -e

DATE = $(shell TZ=UTC0 date -d@$(SOURCE_DATE_EPOCH) +%Y%m%d)
HEXDATE = $(shell printf '0x%08x' $(SOURCE_DATE_EPOCH))

# required in patched mk/efi.mk makefile to link against the gnu-efi package
export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

unexport LDFLAGS

%:
	dh ${@}

override_dh_auto_build-arch:
	$(MAKE) bios DATE="$(DATE)" HEXDATE="$(HEXDATE)"

override_dh_auto_install-arch:
	$(MAKE) bios install INSTALLROOT=$(CURDIR)/debian/tmp

override_dh_auto_build-indep:
	$(MAKE) DATE="$(DATE)" HEXDATE="$(HEXDATE)"

override_dh_auto_install-indep:
	$(MAKE) install INSTALLROOT=$(CURDIR)/debian/tmp

override_dh_auto_test:
	# disabled

override_dh_fixperms:
	dh_fixperms
	# the efi files do not exist when building only the arch dependent packages; ignore exit code of chmod
	-chmod 0644 debian/*/usr/lib/*/efi*/*
	-chmod 0644 debian/*/usr/lib/*/modules/efi*/*

override_dh_install:
	# put documentation files into debian/tmp, organize them in a suitable way
	mkdir -p debian/tmp/usr/share/doc/syslinux-common
	cp -aL README debian/tmp/usr/share/doc/syslinux-common/README.txt
	cp -aL doc debian/tmp/usr/share/doc/syslinux-common/txt
	cp -aL txt debian/tmp/usr/share/doc/syslinux-common/asciidoc
	# rename the package specific documentation files
	mv debian/tmp/usr/share/doc/syslinux-common/txt/logo debian/tmp/usr/share/doc/syslinux-common
	set -e ; \
		for docdir in syslinux extlinux isolinux pxelinux ; do \
		mkdir -p debian/tmp/usr/share/doc/$${docdir} ; \
		mv debian/tmp/usr/share/doc/syslinux-common/txt/$${docdir}.txt debian/tmp/usr/share/doc/$${docdir}/README.txt ; \
		done
	# keytab-lilo is not installed as it's part of the lilo package, also
	# exclude the documentation from being installed
	# separate LICENSE files are not needed, they are covered by
	# debian/copyright
	dh_install -X keytab-lilo.txt -X LICENSE

override_dh_missing:
	dh_missing --fail-missing

override_dh_installchangelogs:
	dh_installchangelogs NEWS

# avoid isohybrid.pl.1 man page to be interpreted as Polish
override_dh_installman:
	dh_installman --language=C

override_dh_gencontrol-indep:
	dh_gencontrol -- -Vbuilt:Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W gnu-efi)"

## syslinux 6.03+git20161205

=== efi/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 2011 Intel Corporation; author: Matt Fleming
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

VPATH = $(SRC)
include $(MAKEDIR)/lib.mk
include $(MAKEDIR)/efi.mk

# Upstream gnu-efi has old-style function definitions.
CFLAGS += -Wno-strict-prototypes

CORE_CSRC := $(wildcard $(core)/*.c $(core)/*/*.c $(core)/*/*/*.c)
CORE_COBJ := $(subst $(core),$(OBJ)/../core,$(patsubst %.c,%.o,$(CORE_CSRC)))

# We don't want to include any of the networking stack or the thread
# code since it will be implemented completely differently for EFI.
FILTERED_OBJS:= $(subst $(core),$(OBJ)/../core,$(patsubst %.c,%.o, \
	$(wildcard $(core)/legacynet/*.c) \
	$(wildcard $(core)/fs/pxe/*.c) \
	$(wildcard $(core)/thread/*.c)))

# Don't include unit tests
FILTERED_OBJS += $(subst $(core),$(OBJ)/../core, \
	$(patsubst %.c,%.o,$(shell find $(core) -path "*/tests/*.c" -print)))

# Don't include console objects
CORE_OBJS = $(filter-out %hello.o %rawcon.o %plaincon.o %strcasecmp.o %bios.o \
	%diskio_bios.o %ldlinux-c.o %isolinux-c.o %pxelinux-c.o \
	%localboot.o %pxeboot.o \
	$(FILTERED_OBJS),$(CORE_COBJ) $(CORE_SOBJ))

CORE_OBJS += $(addprefix $(OBJ)/../core/, \
	fs/pxe/pxe.o fs/pxe/tftp.o fs/pxe/urlparse.o fs/pxe/dhcp_option.o \
	fs/pxe/ftp.o fs/pxe/ftp_readdir.o fs/pxe/http.o fs/pxe/http_readdir.o)

LIB_OBJS = $(addprefix $(objdir)/com32/lib/,$(CORELIBOBJS)) \
	$(LIBEFI)

CSRC = $(wildcard $(SRC)/*.c)
OBJS = $(subst $(SRC)/,,$(filter-out %wrapper.o, $(patsubst %.c,%.o,$(CSRC))))

OBJS += $(objdir)/core/codepage.o $(ARCH)/linux.o

# The DATE is set on the make command line when building binaries for
# official release.  Otherwise, substitute a hex string that is pretty much
# guaranteed to be unique to be unique from build to build.
ifndef HEXDATE
HEXDATE := $(shell $(PERL) $(SRC)/../now.pl $(SRCS))
endif
ifndef DATE
DATE    := $(shell sh $(SRC)/../gen-id.sh $(VERSION) $(HEXDATE))
endif
CFLAGS		+= -DDATE_STR='"$(DATE)"'

$(OBJ)/$(ARCH):
	mkdir -p $@

$(OBJS): | $(OBJ)/$(ARCH)

# The targets to build in this directory
BTARGET  = syslinux.efi

syslinux.so: $(OBJS) $(CORE_OBJS) $(LIB_OBJS)
	$(LD) $(LDFLAGS) --strip-debug -o $@ $^ -lgnuefi -lefi

# We need to rename the .hash section because the EFI firmware
# linker really doesn't like it.
# $(OBJCOPY) --rename-section .gnu.hash=.sdata,load,data,alloc $^ $@
#syslinux.so: syslinux1.so
#	cp $^ $@

wrapper: wrapper.c
	$(CC) $^ -o $@

#
# Build the wrapper app and wrap our .so to produce a .efi
syslinux.efi: syslinux.so wrapper
	$(OBJ)/wrapper syslinux.so $@

all: $(BTARGET)

codepage.o: ../codepage/cp865.cp
	cp $(objdir)/../codepage/cp865.cp codepage.cp
	$(CC) $(SFLAGS) -c -o $@ $(core)/codepage.S

install:
	install -m 755 $(BTARGET) $(INSTALLROOT)$(AUXDIR)

strip:

tidy dist:
	rm -f *.so *.o wrapper
	find . \( -name \*.o -o -name \*.a -o -name .\*.d -o -name \*.tmp \) -print0 | \
		xargs -0r rm -f
	$(topdir)/efi/clean-gnu-efi.sh $(EFI_SUBARCH) $(objdir)

clean: tidy

spotless: clean
	rm -f $(BTARGET)

=== debian/changelog ===
syslinux (3:6.03+git20161205-0) mx; urgency=medium

  * Build from git to incorporate fix for memtest

 -- Timothy E. Harris <maintainer@mepiscommunity.org>  Tue, 06 Dec 2016 14:30:15 -0500

## syslinux 6.04~git20171011.af7e95c3+dfsg1

=== debian/changelog ===
syslinux (3:6.04~git20171011.af7e95c3+dfsg1-6) unstable; urgency=medium

  * gnu-efi compatibility patch: use memset and memcpy from syslinux instead
    of from gnu-efi
    - Using the memset and memcpy from gnu-efi causes some modules (e.g.
      vesamenu.c32) to fail with "Undef symbol FAIL: memset"

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Mon, 03 Dec 2018 22:45:42 +0100

syslinux (3:6.04~git20171011.af7e95c3+dfsg1-5) unstable; urgency=medium

  * Build against gnu-efi >= 3.0.8
  * Bump Standards-Version to 4.2.1.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 13 Oct 2018 11:14:54 +0200

syslinux (3:6.04~git20171011.af7e95c3+dfsg1-4) unstable; urgency=medium

  * Point Vcs-Git and Vcs-Browser to salsa.debian.org.
  * Revert the gnu-efi patch again so that syslinux can be built against
    gnu-efi 3.0.4 from buster.
  * Strip .note.gnu.property section from mbr.bin (added since
    binutils >= 2.31.1-2) to stay within size constraints (Closes: #906414).
  * Fix broken efi binaries when building with binutils >= 2.31 by patching
    the linker script.
  * Bump Standards-Version to 4.2.0.
  * Move to debhelper compatibility level 11.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 18 Aug 2018 17:45:42 +0200

syslinux (3:6.04~git20171011.af7e95c3+dfsg1-3) experimental; urgency=medium

  * Do not create -dbgsym packages for now, as they do not contain any debug
    symbols due to the way syslinux is compiled.
  * Clean up obsolete configuration files in /etc/kernel that are no longer
    present in extlinux since Debian jessie but have never been properly
    removed (Closes: #866343).
  * Build against gnu-efi >= 3.0.6:
    - Split the gnu-efi patch into Debian-specific and non-Debian-specific.
    - Add necessary patches from upstream's mailing list.
    - Adjust the Build-Dependencies.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sun, 03 Dec 2017 11:13:37 +0100

syslinux (3:6.04~git20171011.af7e95c3+dfsg1-2) experimental; urgency=medium

  * Extend 0009-reproducible-build.patch: Also sort file lists obtained using
    `find`, so they are passed to `ar` in a deterministic order.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 04 Nov 2017 11:52:54 +0100

syslinux (3:6.04~git20171011.af7e95c3+dfsg1-1) experimental; urgency=medium

  * Import new version (upstream's current git state, prerelease of
    syslinux 6.04).
    - Booting from XFS now works in MBR partition schemes (Closes: #803938).
  * Remove gnu-efi from the source package so it's not used accidentally.
  * Drop patches included upstream:
    - 0005-load-linux-correct-type.patch
    - 0006-load-linux-protected-mode.patch
    - 0007-sysappend-fix-space-stripping.patch
    - 0008-Fix-gcc-5-ALIGN-causing-Boot-error.patch
    - 0010-fix-ftbfs-with-default-pie.patch
    - 0011-bios-Dont-try-to-guess-the-section-alignment.patch
    - 0012-ldlinux-Fix-return-pointer-to-local-data.patch
    - 0013-extlinux-pull-in-sys_sysmacros.h-for-major_minor_makedev.patch
    - 0016-btrfs-fix.patch
    - 0017-isohdpfx.S-correct-heads-sectors.patch
    - 0018-ext4-Fix-64bit-feature.patch
  * Update patches:
    - 0009-reproducible-build.patch: Drop parts that are included upstream.
    - 0004-gnu-efi.patch: Drop parts that have become unnecessary, because
      upstream checks for a .git directory before trying to update submodules.
  * Remove 0014_fix_ftbfs_no_dynamic_linker.patch which isn't required any
    longer.
  * Improve the extlinux man page (update 0003-extlinux-manpage.patch).
  * Refresh all patches.
  * Add special purpose and debugging MBRs to syslinux-common and isolinux
    packages.
  * Patch upstream changelog to include changes since 6.03.
  * Update debian/copyright as needed.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Thu, 02 Nov 2017 08:51:50 +0100

=== debian/control ===
--- 
+++ 
@@ -4,18 +4,18 @@
 Maintainer: Debian CD Group <debian-cd@lists.debian.org>
 Uploaders: Lukas Schwaighofer <lukas@schwaighofer.name>
 Build-Depends:
- debhelper (>= 10.3),
+ debhelper (>= 11),
  e2fslibs-dev,
  gcc-multilib [amd64 x32],
  libc6-dev-i386 [amd64 x32],
  nasm,
  python,
  uuid-dev,
-Build-Depends-Indep: gnu-efi
-Standards-Version: 4.1.1
+Build-Depends-Indep: gnu-efi (>= 3.0.8)
+Standards-Version: 4.2.1
 Homepage: http://www.syslinux.org/
-Vcs-Git: https://anonscm.debian.org/git/debian-cd/syslinux.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-cd/syslinux.git
+Vcs-Git: https://salsa.debian.org/images-team/syslinux.git
+Vcs-Browser: https://salsa.debian.org/images-team/syslinux
 
 Package: syslinux
 Architecture: amd64 i386 x32

## syslinux 6.04~git20190206.bf6db5b4%2Bdfsg1

=== memdisk/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 2001-2009 H. Peter Anvin - All Rights Reserved
##   Copyright 2009 Intel Corporation; author: H. Peter Anvin
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

include $(MAKEDIR)/embedded.mk
-include $(topdir)/version.mk

INCLUDES = -I$(topdir)/com32/include -I$(objdir)
CFLAGS  += -D__MEMDISK__ -DDATE='"$(DATE)"' -mregparm=3 -DREGPARM=3
LDFLAGS  = $(GCCOPT) -g
NASM     = nasm
NASMOPT  = -Ox
NFLAGS   = -dDATE='"$(DATE)"'
NINCLUDE = -I$(SRC)/

VPATH = $(SRC)
SRCS	 = $(sort $(wildcard *.asm *.c *.h))

# The DATE is set on the make command line when building binaries for
# official release.  Otherwise, substitute a hex string that is pretty much
# guaranteed to be unique to be unique from build to build.
ifndef HEXDATE
HEXDATE := $(shell $(PERL) $(SRC)/../now.pl $(SRCS))
endif
ifndef DATE
DATE    := $(shell sh $(SRC)/../gen-id.sh $(VERSION) $(HEXDATE))
endif

# Important: init.o16 must be first!!
OBJS16   = init.o16 init32.o
OBJS32   = start32.o setup.o msetup.o e820func.o conio.o memcpy.o memset.o \
	   memmove.o unzip.o dskprobe.o eltorito.o \
	   ctypes.o strntoumax.o strtoull.o suffix_number.o \
	   memdisk_chs_512.o memdisk_edd_512.o \
	   memdisk_iso_512.o memdisk_iso_2048.o

CSRC     = setup.c msetup.c e820func.c conio.c unzip.c dskprobe.c eltorito.c \
	   ctypes.c strntoumax.c strtoull.c suffix_number.c
SSRC     = start32.S memcpy.S memset.S memmove.S
NASMSRC  = memdisk_chs_512.asm memdisk_edd_512.asm \
	   memdisk_iso_512.asm memdisk_iso_2048.asm \
	   memdisk16.asm

all: memdisk # e820test

# tidy, clean removes everything except the final binary
tidy dist:
	rm -f *.o *.s *.tmp *.o16 *.s16 *.bin *.lst *.elf e820test .*.d
	rm -f *.map

clean: tidy

# spotless also removes the product binary
spotless: clean
	rm -f memdisk .depend

memdisk16.o: memdisk16.asm

# Cancel rule
%.o: %.asm

memdisk16.o: memdisk16.asm
	( $(NASM) -M -DDEPEND $(NFLAGS) $(NINCLUDE) -o $@ $< ; echo '' ) > .$@.d ; true
	$(NASM) -f elf $(NASMOPT) $(NFLAGS) $(NINCLUDE) -o $@ -l $*.lst $<

.PRECIOUS: %.bin
%.bin: %.asm
	( $(NASM) -M -DDEPEND $(NFLAGS) $(NINCLUDE) -o $@ $< ; echo '' ) > .$@.d ; true
	$(NASM) -f bin $(NASMOPT) $(NFLAGS) $(NINCLUDE) -o $@ -l $*.lst $<

memdisk_%.o: memdisk_%.bin
	$(LD) --oformat elf32-i386 -r -b binary -o $@ $<

memdisk16.elf: $(OBJS16)
	$(LD) -Ttext 0 -o $@ $^

#memdisk32.elf: memdisk.ld $(OBJS32)
memdisk32.elf: $(ARCH)/memdisk.ld $(OBJS32)
	$(LD) -o $@ -T $^

%.bin: %.elf
	$(OBJCOPY) -O binary $< $@

memdisk: memdisk16.bin memdisk32.bin postprocess.pl
	$(PERL) $(SRC)/postprocess.pl $@ memdisk16.bin memdisk32.bin

e820test: e820test.c e820func.c msetup.c
	$(CC) -m32 -g $(GCCWARN) -DTEST -o $@ $^

# This file contains the version number, so add a dependency for it
setup.s: ../version

# Include dependencies file
-include .*.d
